<template>
  <GenericLayout>
    <template #header>
      <Header
        :back-button="true"
        :title="pageTitle"
      />
    </template>

    <template
      #page-content
    >
      <div class="full-height column">
        <template v-if="isDesktopPlatform">
          <div
            class="page-title"
            v-if="pageTitle"
          >
            {{ pageTitle }}
          </div>
          <div
            class="page-subtitle"
            v-if="pageSubTitle"
          >
            {{ pageSubTitle }}
          </div>
        </template>
        <q-card
          :square="!isDesktopPlatform"
          class="column no-wrap col"
        >
          <q-card-section>
            <div
              class="text-body2 q-mb-sm"
            >
              <translate>Did you bury the residues of this crop ?</translate>
            </div>
            <q-btn-toggle
              v-model="storeResiduesAreBuried"
              :options="[{value: true, label: $gettext('Yes')}, {value: false, label: $gettext('No')}]"
              toggle-color="primary"
            />
          </q-card-section>

          <template v-if="storeResiduesAreBuried">
            <q-card-section>
              <div
                class="text-body2 q-mb-sm"
              >
                <translate>What was your crop yield ?</translate>
              </div>
              <q-input
                v-model="storeCropYieldPerCycle"
                filled
                type="number"
                :suffix="$pgettext('ton per hectare', 't/ha')"
                min="0"
                :rules="customInputRules"
              />
            </q-card-section>
            <q-card-section>
              <div
                class="text-body2 q-mb-sm"
              >
                <translate>What was the humidity of your crop yield ?</translate>
              </div>
              <q-input
                v-model="storeCropYieldHumidityPerCycle"
                filled
                type="number"
                suffix="%"
                :min="minHumidity"
                :max="maxHumidity"
                :rules="customInputRulesPositiveOrNullNumber"
              />
            </q-card-section>
          </template>

          <!-- buttons -->
          <q-card-section class="q-mt-auto">
            <q-card-actions
              vertical
              align="stretch"
              class="q-pa-none"
            >
              <q-btn
                color="primary"
                text-color="white"
                :disable="!canContinue"
                @click="onClickNext"
              >
                <translate>Next</translate>
              </q-btn>
              <q-btn
                flat
                color="primary"
                @click="onClickPrevious"
              >
                <translate>Previous</translate>
              </q-btn>
            </q-card-actions>
          </q-card-section>
        </q-card>
      </div>
    </template>

    <template #footer>
      <Footer />
    </template>
  </GenericLayout>
</template>

<script>
import { PlatformMixin } from 'src/mixins/PlatformMixin'
import GenericLayout from 'src/layouts/GenericLayout'
import Header from 'src/components/layouts/Header'
import Footer from 'src/components/layouts/Footer'

import AlgorithmsMixins from 'src/pages/fieldbook/fertilization/algorithms/common/mixins/AlgorithmsMixins'
import VisioneMixins from 'src/pages/fieldbook/fertilization/algorithms/visione/mixins/VisioneMixins'

export default {
  name: 'VisionePreviousCampaignResiduesPage',
  components: {
    GenericLayout,
    Header,
    Footer
  },
  mixins: [PlatformMixin, AlgorithmsMixins, VisioneMixins],
  data () {
    return {
      minHumidity: 0,
      maxHumidity: 100
    }
  },
  computed: {
    canContinue () {
      return this.storeResiduesAreBuried != null && (
        this.storeResiduesAreBuried
          ? this.storeCropYieldPerCycle != null && this.storeCropYieldHumidityPerCycle != null
          : true
      )
    },
    customInputRules () {
      return [
        val => !isNaN(val) || `${this.$gettext('Must be a number')}`,
        val => !!val || `* ${this.$gettext('This field is required')}`,
        val => val >= 0 || `${this.$gettext('Must be positive')}`
      ]
    },
    customInputRulesPositiveOrNullNumber () {
      return [
        val => !isNaN(val) || `${this.$gettext('Must be a number')}`,
        val => val >= 0 || `${this.$gettext('Must be positive')}`
      ]
    },
    pageTitle () {
      return this.$gettext('Previous Campaign - Residues')
    },
    pageSubTitle () {
      return 'Visione'
    },
    storeResiduesAreBuried: {
      get () {
        return this.$store.state.fertilizationPlan.parameters?.previous_rotation?.residues_are_buried
      },
      set (v) {
        this.updatePreviousRotationParameter('residues_are_buried', v)
      }
    },
    storeCropCycles: {
      get () {
        return this.$store.state.fertilizationPlan.parameters?.previous_rotation?.crop_cycles
      },
      set (v) {
        this.updatePreviousRotationParameter('crop_cycles', v)
      }
    },
    storeCropYieldPerCycle: {
      get () {
        return this.$store.state.fertilizationPlan.parameters?.previous_rotation?.crop_yield_per_cycle
      },
      set (v) {
        this.updatePreviousRotationParameter('crop_yield_per_cycle', v)
      }
    },
    storeCropYieldHumidityPerCycle: {
      get () {
        return this.$store.state.fertilizationPlan?.parameters?.previous_rotation?.crop_yield_humidity_per_cycle
      },
      set (value) {
        this.updatePreviousRotationParameter('crop_yield_humidity_per_cycle', Number(value) < 0 ? 0 : Number(value) > 100 ? 100 : Math.round(value))
      }
    }
  },
  apollo: {
  },
  methods: {
    onClickNext () {
      this.$router.push({
        name: 'visionePreviousCampaignOrganicFertilization'
      })
    },
    onClickPrevious () {
      this.$router.replace({
        name: 'visionePreviousCampaignProfile'
      })
    }
  },
  mounted () {
    this.storeCropCycles = 1
    if (this.storeCropYieldHumidityPerCycle == null) {
      this.storeCropYieldHumidityPerCycle = this.$store.state.fertilizationPlan?.parameters?.previous_rotation?.visione_profile?.humidity
    }
    this.minHumidity = this.$store.state.fertilizationPlan?.parameters?.previous_rotation?.visione_profile?.min_humidity ?? 0
    this.maxHumidity = this.$store.state.fertilizationPlan?.parameters?.previous_rotation?.visione_profile?.max_humidity ?? 100
  }
}
</script>
